//+------------------------------------------------------------------
// this version by mladen
//+------------------------------------------------------------------
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 DeepSkyBlue
#property indicator_color4 PaleVioletRed
#property indicator_width3 1
#property indicator_width4 1

//
//
//
//
//

extern string TimeFrame          = "Current time frame";
extern int    MA_Price           = 0;
extern int    MA_Length          = 4;
extern int    MA_Mode            = 0;
extern int    GaussOrder         = 3;
extern int    AtrLength          = 11; 
extern double Kv                 = 4;  
extern double MoneyRisk          = 1; 
extern bool   usePrice_HiLoBreak = true;
extern bool   useMA_HiLoEnvelope = false;
extern int    VisualMode         = 0;  

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav"; 

//
//
//
//
//

double UpLine[];
double DnLine[]; 
double UpArrow[];
double DnArrow[]; 
double smax[];
double smin[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;
double coeffs[][3];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,UpLine);  
      SetIndexBuffer(1,DnLine);  
      SetIndexBuffer(2,UpArrow); 
      SetIndexBuffer(3,DnArrow); 
      SetIndexBuffer(4,smax);
      SetIndexBuffer(5,smin);
      SetIndexBuffer(6,trend);
      
      if (MA_Mode==4) InitCoeffs(MA_Length,GaussOrder);
      if(VisualMode==0)
      {
         SetIndexStyle(0,DRAW_LINE);
         SetIndexStyle(1,DRAW_LINE);
      }
      else
      {
         SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,159);
         SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,159);
      }
      SetIndexStyle(2,DRAW_ARROW);SetIndexArrow(2,108);
      SetIndexStyle(3,DRAW_ARROW);SetIndexArrow(3,108);
      
      //
      //
      // 
      //
      //
      
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
       
      IndicatorShortName(timeFrameToString(timeFrame)+"  Volty Channel Stop");
      return(0);
}
      
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double prices[][4];

int start()
{
   int counted_bars=IndicatorCounted();
   int i,g,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { UpLine[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(prices,0)!=Bars) ArrayResize(prices,Bars);
      for(i=limit, r=Bars-i-1; i>=0; i--,r++)
      { 
         if (MA_Mode==4)
         {
            if(useMA_HiLoEnvelope)
            { 
               prices[r][0] = High[i]; 
               prices[r][1] = Low[i];
            }
            else
            {
               prices[r][0] = iMA(NULL,0,1,0,MODE_SMA,MA_Price,i);
               prices[r][1] = prices[r][0];
            }
            
            double sign = 1;
               prices[r][2] = prices[r][0]*coeffs[GaussOrder][1];
               for (g=1; g <= GaussOrder; g++, sign *= -1.0)
                     prices[r][2] += sign*coeffs[g][0]*coeffs[g][2]*prices[r-g][2];
               sign = 1;                     
               prices[r][3] = prices[r][1]*coeffs[GaussOrder][1];
               for ( g=1; g <= GaussOrder; g++, sign *= -1.0)
                     prices[r][3] += sign*coeffs[g][0]*coeffs[g][2]*prices[r-g][3];

            //
            //
            //
            //
            //
            
            double bprice = prices[r][2];
            double sprice = prices[r][3];
         } 
         else
         {
            if(useMA_HiLoEnvelope)
            {
               bprice=iMA(NULL,0,MA_Length,0,MA_Mode,2,i);
               sprice=iMA(NULL,0,MA_Length,0,MA_Mode,3,i);
            }
            else
            {
               bprice=iMA(NULL,0,MA_Length,0,MA_Mode,MA_Price,i);
               sprice=iMA(NULL,0,MA_Length,0,MA_Mode,MA_Price,i);
            }
         }            
         smin[i]    = sprice - Kv * iATR(NULL,0,AtrLength,i); 
	      smax[i]    = bprice + Kv * iATR(NULL,0,AtrLength,i);
         UpLine[i]  = EMPTY_VALUE;
         DnLine[i]  = EMPTY_VALUE;
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1]; 
   
         //
         //
         //
         //
         //

         if(usePrice_HiLoBreak)
         {
            if(High[i] > smax[i+1]) trend[i]=  1;
            if(Low[i]  < smin[i+1]) trend[i]= -1;
         }
         else
         {        
            if (bprice > smax[i+1]) trend[i] =  1;
            if (sprice < smin[i+1]) trend[i] = -1;
         }            
         if (trend[i] == 1)
         {  
     	      if (smin[i] < smin[i+1]) smin[i] = smin[i+1];
               UpLine[i] = smin[i] - (MoneyRisk - 1.0) * iATR(NULL,0,AtrLength,i); if (trend[i+1]!= 1) UpArrow[i] = UpLine[i];
         }
         if (trend[i] ==-1)
         {  
    	      if (smax[i] > smax[i+1]) smax[i] = smax[i+1];
               DnLine[i] = smax[i] + (MoneyRisk - 1.0) * iATR(NULL,0,AtrLength,i); if (trend[i+1]!=-1) DnArrow[i] = DnLine[i];
         }
      }
      manageAlerts();
      return(0);
   }
      
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit;i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         UpLine[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MA_Price,MA_Length,MA_Mode,GaussOrder,AtrLength,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,0,y);
         DnLine[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MA_Price,MA_Length,MA_Mode,GaussOrder,AtrLength,Kv,MoneyRisk,usePrice_HiLoBreak,useMA_HiLoEnvelope,1,y);
         UpArrow[i] = EMPTY_VALUE;
         DnArrow[i] = EMPTY_VALUE;
            if (UpLine[i]!= EMPTY_VALUE && UpLine[i+1]==EMPTY_VALUE) UpArrow[i]=UpLine[i];
            if (DnLine[i]!= EMPTY_VALUE && DnLine[i+1]==EMPTY_VALUE) DnArrow[i]=DnLine[i];
   }
   manageAlerts();  
   return(0);         
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//
//
//
//
//

void manageAlerts()
{
   if (! calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" Volty Channel Stop ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Volty Channel Stop "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define Pi 3.141592653589793238462643

void InitCoeffs(int length, int n)
{
   double b = (1.0 - MathCos(2.0*Pi/length))/(MathPow(MathSqrt(2.0),2.0/n) - 1.0);
   double a = -b + MathSqrt(b*b + 2.0*b);

   ArrayResize(coeffs,n+1);
   for(int r=0; r<=n; r++)
   {
       coeffs[r][0] = fact(n)/(fact(n-r)*fact(r));
       coeffs[r][1] = MathPow(    a,r);
       coeffs[r][2] = MathPow(1.0-a,r);
   }
}

//
//
//
//
//

double fact(int n)
{
   double a=1;
         for(int i=1; i<=n; i++) a*=i;
   return(a);
}